<html>
<head><title>CSqlDriver Test Suite</title></head>
<body>
<?php

//////////////////////////////////////////////////////////////////////
/*

poko2 CSqlDriver Test Suite

o This test suite tests interface methods of CSqlDriver class.

CREATE TABLE testsuite (
	id integer,
	name varchar(256),
	mail varchar(256)
	);
INSERT INTO testsuite VALUES(1, 'user1', 'user1@example.com');
INSERT INTO testsuite VALUES(2, 'user2', 'user2@example.com');
INSERT INTO testsuite VALUES(3, 'user3', 'user3@example.com');
INSERT INTO testsuite VALUES(4, 'user4', 'user4@example.com');
INSERT INTO testsuite VALUES(5, 'user5', 'user5@example.com');
INSERT INTO testsuite VALUES(6, 'user6', 'user6@example.com');

*/
//////////////////////////////////////////////////////////////////////
//

// Implementing Data check by JavaScript is Good Idea!!
function IsArrayIsset($target, $keys)
{
	$result = 0;
	foreach($keys as $key)
		$result += ($target[$key] == "");
	return $result;
}

$checkkeys = array(
	"host", "database", "port", "user", "password", "table"
);

if(IsArrayIsset($HTTP_POST_VARS, $checkkeys))
{
?>
<h3>Specify Database Informations.</h3>
<form action="testsuite.php" method="post">
<table border>

<tr><td>DriverClass</td><td>

<select name="driverclass">
<option value="pgsql">PostgreSQL
<option value="mysql">MySQL
</select>
</td></tr>

<tr><td>Host</td><td>
<input type="text" name="host" value="<?php print $HTTP_POST_VARS[host]; ?>">
</td></tr>

<tr><td>Database</td><td>
<input type="text" name="database" value="<?php print $HTTP_POST_VARS[database]; ?>">
</td></tr>

<tr><td>Port</td><td>
<input type="text" name="port" value="<?php print $HTTP_POST_VARS[port]; ?>">
</td></tr>

<tr><td>User</td><td>
<input type="text" name="user" value="<?php print $HTTP_POST_VARS[user]; ?>">
</td></tr>

<tr><td>Password</td><td>
<input type="password" name="password" value="<?php print $HTTP_POST_VARS[password] ?>">
</td></tr>

<tr><td>Table</td><td>
<input type="text" name="table" value="<?php print $HTTP_POST_VARS[table]; ?>">
</td></tr>

<table>
<input type="submit" value=">> test >>">
</form>
<?php
} else {

include("cls_sqldriver.php");

$CoreConfig = array(

	// poko2 install dir
	"PokoInstallDir" => "../"
	);

// Sql Driver Class Name ( $DriverClass.php )
// (Change Class Name in your case.)
$DriverClass = $HTTP_POST_VARS["driverclass"];

$SqlConfig = array(
	"DriverClass" => $DriverClass,
	"Host" => $HTTP_POST_VARS["host"],
	"Database" => $HTTP_POST_VARS["database"],
	"Port" => $HTTP_POST_VARS["port"],
	"User" => $HTTP_POST_VARS["user"],
	"Password" => $HTTP_POST_VARS["password"]
	);

$obj = new CSqlDriver($CoreConfig, $SqlConfig);
$sql = "select * from $HTTP_POST_VARS[table]";

$obj->SqlConnect();
$obj->SqlExec($sql);

$cols = $obj->SqlNumFields();
$rows = $obj->SqlNumRows();

?>
<h3>SQL Query, Result rows and cols.</h3>
<table border>
<tr><td colspan="2"><?php print $sql; ?></td></tr>
<tr><td>SqlNumRows()</td><td><?php print $rows; ?></td></tr>
<tr><td>SqlNumFields()</td><td><?php print $cols; ?></td></tr>
</table>
<?php
if($rows) {
	print "<h3>SqlFetchArray(0)</h3>\n";
	print_r($obj->SqlFetchArray(0));

	print "\n<h3>SqlResult(\$i, \$j) and SqlFieldName(\$j) Recursive.</h3>\n";

	print "<table border>\n";

	print "<tr>\n";
	for($j = 0; $j < $cols; $j++)
		print "<td>".$obj->SqlFieldName($j)."</td>\n";
	print "</tr>\n";

	for($i = 0; $i < $rows; $i++) {
		print "<tr>\n";
		for($j = 0; $j < $cols; $j++)
			print "<td>".$obj->SqlResult($i, $j)."</td>\n";
		print "</tr>\n";
	}

	print "</table>\n";

}


$obj->SqlFreeResult();
$obj->SqlDisconnect();
}
?>
</body>
</html>
