<html>
<head><title>CDbManager Test Tool</title>
<style type="text/css">
<!--
a.pdbm { text-decoration: none; background-color: none }
a.pdbm:link { color: black; background-color: none }
a.pdbm:visited { color: gray; background-color: none }
a.pdbm:active { color: black; background-color: gray }
a.pdbm:hover { color: white; background-color: gray }

table.pdbm {
	border-width: 1px;
	border-style: solid;
	border-color: black;
	background: #ccc;
	}

td.pdbm_f {
	padding: 2px;
	background: #ddd;
	text-align: right;
	}

td.pdbm_v {
	padding: 2px;
	background: white;
	}

td.pdbm_v_odd {
	padding: 2px;
	background: #efefef;
	}

input.pdbm {
	margin: 2px;
	padding: 2px;
	color: black; background: white;
	border-left:1px;
	border-right:1px;
	border-top:1px;
	border-bottom:1px solid black;
	}

input.pdbmbtn {
	margin: 1px;
	padding: 2px;
	color: black; background: #e8e8e8;
	border-width: 1px;
	border-style: solid;
	border-color: black;
	}

textarea.pdbm  {
	margin: 2px;
	padding: 2px;
	color: black; background: white;
	border-width: 1px;
	border-style: solid;
	border-color: black;
	}

select.pdbm {
	margin: 2px;
	padding: 2px;
	color: black; background: white;
	border-left:1px;
	border-right:1px;
	border-top:1px;
	border-bottom:1px solid black;
	}

span.pdbm_error {
	margin: 2px;
	color: red;
	border-bottom: 1px dashed red;
	}

strong.pdbm_error {
	color: blue;
	background-color: #dddde7;
	border: 1px solid blue
	}

-->
</style>
</head>
<body>
<center>
<?php
$include_dir = "../";
require($include_dir."sqldriver/cls_sqldriver.php");
require($include_dir."kernel/cls_form.php");
require($include_dir."kernel/cls_dbmanager.php");

define("_DCF_SAMPLE", _DCF_URL << 1);

$CoreConfig = array(
	// poko2 򥤥󥹥ȡ뤷ǥ쥯ȥ
	// (ǻȤΤǡάʤǲ)
	// ("/" ǽ餻Ʋ)
	"PokoInstallDir" => "../"
	);

$SqlConfig = array(
	"DriverClass" => "pgsql", // ɥ饤Х饹̾: ŬѹƲ
	"Host" => "localhost",
	"Database" => "testsuite",
	"Port" => "5432",
	"User" => "fenjin",
	"Password" => ""
	);

$TableInfo = array(
	"Table" => "sample",
	"PKFieldName" => "id",
	"FormValueArray" => "HTTP_POST_VARS"
	);

$TableStruct = array(
	array("type" => "integer",
		"size" => 4,
		"field" => "id",
		"alias" => "ID",
		"dcf" => _DCF_NOT_NULL | _DCF_NUMBER,
		"dvf" => _DVF_ALL),
	array("type" => "varchar",
		"size" => 256,
		"field" => "name",
		"alias" => "̾",
		"dcf" => _DCF_NOT_NULL,
		"dvf" => _DVF_ALL),
	array("type" => "text",
		"size" => "",
		"field" => "comment",
		"alias" => "",
		"dcf" => _DCF_SAMPLE,
		"dvf" => _DVF_LIST_HIDDEN),
	array("type" => "integer",
		"size" => 4,
		"field" => "gid",
		"alias" => "롼",
		"dcf" => _DCF_NOT_NULL | _DCF_INTEGER,
		"dvf" => _DVF_ALL)
	);

class MyDbManager extends CDbManager {

	// ؤΤᡢ顼ååХåե󥰤̵ޤ
	var $IsDCEMessageBuffering = false;

//	var $debug = true;

	function MyDbManager($CoreConfig,
						$SqlConfig,
						$TableInfo, 
						$TableStruct)
	{
		$this->CDbManager($CoreConfig,
						$SqlConfig, 
						$TableInfo, 
						$TableStruct);
	}

	function GetFieldHtmlOutput($array, $data, $mode, &$html)
	{
		switch($array[field]) {
			case "comment":
				$_data = htmlspecialchars($data);
				$_data = nl2br($_data);
				$html = $_data;
				return true;
			case "gid":
				$sql = "select gname from sample_sub where gid = '$data'";
				$result = $this->SqlDriver->_SqlExec($sql);
				if($result && 0 < $this->SqlDriver->SqlNumRows($result))
					$gname = $this->SqlDriver->SqlResult(0, 0, $result);
				else $gname = "unknown";
				$this->SqlDriver->SqlFreeResult($result);
				$html = $gname;
				return true;
			default:
				return false;
		}
	}

	function DataInputFormTrap($array, $data, $mode, &$form)
	{
		switch($array[field]) {

			case "id":
				if($mode == "insert") $data = $this->SqlMaxId() + 1;
				$form = "$data".$this->ObjForm->_HiddenForm(
							array($array[field] => $data));
				return true;

			case "comment":
				if($mode == "insert") $data = "";
				$form = $this->ObjForm->_TextAreaForm(
							array("rows" => 3, "cols" => 20,
								"name" => $array[field],
								"class" => "pdbm"),
							$data);
				return true;

			case "gid":
				if($mode == "insert") $data = 0;
				$options = array();
				$default = 0;
				$sql = "select gid, gname from sample_sub";
				$result = $this->SqlDriver->_SqlExec($sql);
				for($i = 0;
					$i < $this->SqlDriver->SqlNumRows($result);
					$i++) {
					$gid = $this->SqlDriver->SqlResult($i, 0, $result);
					$gname = $this->SqlDriver->SqlResult($i, 1, $result);
					if($gid == $data) $default = $i;
					$options[$gname] = $gid;
				}
				$this->SqlDriver->SqlFreeResult($result);
				$form = $this->ObjForm->_SelectForm(
					array("name" => $array[field], "class" => "pdbm"),
					$options,
					$default);
				return true;

			default:
				return false;
		}
	}

	function GetDcfEndBit()
	{ 
		return _DCF_SAMPLE;
	}

	function InitDataCheckMapTrap()
	{
		$this->DataCheckMap[_DCF_SAMPLE] = "_DCH_Sample";
	}

	function _DCH_Sample($structure, $data)
	{
		$this->DataCheckError("ץ륨顼(롼)", $structure[alias]);
		return false;
	}
};

$ObjForm = new CForm;
$ObjForm->Action = $HTTP_SERVER_VARS[PHP_SELF];
$ObjForm->Method = "post";

$ObjDbManager = new MyDbManager(
	$CoreConfig,
	$SqlConfig,
	$TableInfo,
	$TableStruct);
$ObjDbManager->ObjForm = &$ObjForm;

$ObjDbManager->SqlDriver->SqlConnect();

function print_s_button($submit = "- send -")
{
	global $ObjForm;
	print("<br>\n");
	$ObjForm->SubmitForm(array(
					"value" => $submit,
					"class" => "pdbmbtn"
					));
	print("\n");
}

function print_sr_button($submit = "- send -", $reset = "- clear -")
{
	global $ObjForm;
	print("<br>\n");
	$ObjForm->SubmitForm(array(
				"value" => $submit,
				"class" => "pdbmbtn"
				));
	$ObjForm->ResetForm(array(
				"value" => $reset,
				"class" => "pdbmbtn"
				));
	print("\n");
}

$html = "";
switch($HTTP_GET_VARS[mode]) {
	case "detail":
		$pkey = $HTTP_GET_VARS[$ObjDbManager->PKFieldName];

		$action_buf = $ObjForm->Action;
		$ObjForm->Action .= "?mode=update";
		$ObjForm->StartForm();
		$ObjForm->HiddenForm(array($ObjDbManager->PKFieldName => $pkey));
		print_s_button("- update -");
		$ObjForm->EndForm();

		$ObjDbManager->GetDetail($html, $pkey);
		print $html;

		$ObjForm->Action = $action_buf . "?mode=delete_confirm";
		$ObjForm->StartForm();
		$ObjForm->HiddenForm(array($ObjDbManager->PKFieldName => $pkey));
		print_s_button("- delete -");
		$ObjForm->EndForm();

		break;

	case "insert":
		$ObjForm->Action .= "?mode=insert_confirm";
		$ObjForm->StartForm();

		$ObjDbManager->InsertTable($html);
		print $html;

		print_sr_button();
		$ObjForm->EndForm();
		break;

	case "insert_confirm":
		$ObjForm->Action .= "?mode=insert_execute";
		$ObjForm->StartForm();

		if($ObjDbManager->InsertConfirm($html)) {
			print $html;
			print_s_button();
		}

		$ObjForm->EndForm();
		break;

	case "insert_execute":

		$ObjDbManager->InsertExecute($html);
		print $html;

		print("<center><a href=\"$HTTP_SERVER_VARS[PHP_SELF]\" ".
				"class=\"pdbm\" >list</a></center>\n");
		break;

	case "update":
		$ObjForm->Action .= "?mode=update_confirm";
		$ObjForm->StartForm();

		$ObjDbManager->UpdateTable($html);
		print $html;

		print_sr_button();
		$ObjForm->EndForm();
		break;

	case "update_confirm":
		$ObjForm->Action .= "?mode=update_execute";
		$ObjForm->StartForm();

		if($ObjDbManager->UpdateConfirm($html)) {
			print $html;
			print_s_button();
		}

		$ObjForm->EndForm();
		break;

	case "update_execute":

		$ObjDbManager->UpdateExecute($html);
		print $html;

		print("<center><a href=\"$HTTP_SERVER_VARS[PHP_SELF]\" ".
				"class=\"pdbm\" >list</a></center>\n");
		break;

	case "delete_confirm":
		$pkey = $ObjDbManager->FormValueArray[$ObjDbManager->PKFieldName];

		print("<center>Delete This Record.</center><br>\n");

		$ObjDbManager->DeleteConfirm($html);
		print $html;

		$ObjForm->Action .= "?mode=delete_execute";
		$ObjForm->StartForm();
		$ObjForm->HiddenForm(array($ObjDbManager->PKFieldName => $pkey));
		print_s_button("- delete -");
		$ObjForm->EndForm();

		break;

	case "delete_execute":

		$ObjDbManager->DeleteExecute($html);
		print $html;

		print("<center><a href=\"$HTTP_SERVER_VARS[PHP_SELF]\" ".
				"class=\"pdbm\" >list</a></center>\n");
		break;

	default:
		$html = "<center><a href=\"$HTTP_SERVER_VARS[PHP_SELF]?".
				"mode=insert".
				"\" class=\"pdbm\">insert</a></center><br>";
		print $html;
		$ObjDbManager->GetList($html);
		print $html;
}

$ObjDbManager->SqlDriver->SqlDisconnect();
?>

<br>
<a href="JavaScript:history.go(-1)" class="pdbm">back</a>
<br>
<a href="simple_dbmanager.txt" target="_blank" class="pdbm">
See documents of this Test Tool.
</a>
</center>
</body>
</html>
