<?php

//////////////////////////////////////////////////////////////////////
/*

o PostgreSQLSQLɥ饤

o оPHP PHP 4.1 ʾ塣

(PHPƱ᥸㡼СǤ⡢ޥʡֹˤäPostgreSQLϴؿ
̯ѹƤ롣ߴݻ뤬Ūݾڤ̵)

*/
//////////////////////////////////////////////////////////////////////
//

class pgsql {

//////////////////////////////////////////////////////////////////////
//
// Members Definition
//

	////////////////////////////////////////
	//
	// Core Connect Informations
	//

	// Configuration Array
	var $SqlConfig;

	// Connect Variables
	var $_Host     = "";
	var $_Database = "";
	var $_Port     = "";
	var $_User     = "";
	var $_Password = "";

	// Debut Flag
	var $debug = false;

	// Connection Id
	var $Conn = false;

	// SQL Query Result ID
	var $Result = 0;

//
//////////////////////////////////////////////////////////////////////
//
// Methods Implementation
//

	// Simple (debug) messaging
	function message($str, $is_debug = 0)
	{
		if($is_debug) {
			if($this->debug) printf($str);
		} else printf($str);
	}

	////////////////////////////////////////
	//
	// Constructor
	//
	function pgsql($array)
	{
		$this->_Host = $array["Host"];
		$this->_Database = 
						$array["DatabasePrefix"].
						$array["Database"].
						$array["DatabaseSuffix"];
		$this->_Port = $array["Port"];
		$this->_User = $array["User"];
		$this->_Password = $array["Password"];
		$this->SqlConfig = $array;
	}

	////////////////////////////////////////
	//
	// Create Connection
	//
	function SqlConnect()
	{
		if($this->Conn == false) {
			$buf = sprintf(
				"host=%s port=%s dbname=%s user=%s password=%s",
				$this->_Host,
				$this->_Port,
				$this->_Database,
				$this->_User,
				$this->_Password);
			$this->message("aurhorization option...$buf", true);

			$this->Conn = @pg_connect($buf);
			if($this->Conn == false) {
				$this->message(
					"Failed for connecting database...($buf)\n",
					true);
				return false;
			}
		}
		return($this->Conn);
	}

	////////////////////////////////////////
	//
	// Destroy Connection
	//
	function SqlDisconnect()
	{
		if($this->Conn != false) {
			if($this->Result) $this->SqlFreeResult();
			@pg_close($this->Conn);
			$this->Conn = false;
		}
	}

	function SqlExec($query)
	{
		if($this->Result) $this->SqlFreeResult();
		$this->Result = $this->_SqlExec($query);
		return $this->Result;
	}

	function _SqlExec($query)
	{
		$this->message($query, true);
		$result = @pg_exec($query);
		if (!$result) {
			$this->message(
				"Failed for SQL query.<br>\n$query<br>\n",
				true);
			return false;
		}
		return $result;
	}

	function SqlFreeResult($result = null)
	{
		if(isset($result)) $this->_SqlFreeResult($result);
		else {
			$this->_SqlFreeResult($this->Result);
			$this->Result = 0;
		}
	}

	function _SqlFreeResult($result)
	{
		pg_freeresult($result);
	}

	function SqlFetchArray($i, $result = 0)
	{
		$_result = ($result) ? $result : $this->Result;
		return $this->_SqlFetchArray($i, $_result);
	}

	function _SqlFetchArray($i, $result)
	{
		return pg_fetch_array($result, $i);
	}

	function SqlNumFields($result = 0)
	{
		$_result = ($result) ? $result : $this->Result;
		return pg_numfields($_result);
	}

	function SqlNumRows($result = 0)
	{
		$_result = ($result) ? $result : $this->Result;
		return pg_numrows($_result);
	}

	function SqlFieldName($field, $result = 0)
	{
		$_result = ($result) ? $result : $this->Result;
		return pg_fieldname($_result, $field);
	}

	function SqlResult($rows, $cols, $result = 0)
	{
		$_result = ($result) ? $result : $this->Result;
		return pg_result($_result, $rows, $cols);
	}
};

//
//////////////////////////////////////////////////////////////////////

?>
