<html>
<head><title>CForm Test Tool</title>
<style type="text/css">
<!--
table.header {
	border-width: 1px;
	border-style: solid;
	border-color: black;
	}

input.sample1 {
	color: black; background: white;
	border-left:1px;
	border-right:1px;
	border-top:1px;
	border-bottom:1px solid black;
	}

textarea.sample1  {
	color: black; background: white;
	border-width: 1px;
	border-style: solid;
	border-color: black;
	}

select.sample1 {
	color: black; background: white;
	border-left:1px;
	border-right:1px;
	border-top:1px;
	border-bottom:1px solid black;
	}

-->
</style>
</head>
<body>

<?php
require("../kernel/cls_form.php");
$form = new CForm;
$form->Action = $HTTP_SERVER_VARS[PHP_SELF];

$form->StartForm();
?>

<table class="header" cellspacing=10>

<tr>
<td>text</td>
<td>
<?php

$value = ($HTTP_POST_VARS["textsample"] == "") ?
			"\"Default Text\" , 'Value'" :
			$HTTP_POST_VARS["textsample"];

$form->TextForm(array(
		"size" => "20", "value" => $value,
		"maxlength" => "30", "name" => "textsample",
		"class" => "sample1"));
?>
</td>
</tr>

<tr>
<td>password</td>
<td>
<?php

$value = ($HTTP_POST_VARS["passwordsample"] == "") ?
			"\"Default Password\"" :
			$HTTP_POST_VARS["passwordsample"];


$form->PasswordForm(array(
		"size" => "20", "value" => $value,
		"maxlength" => "30", "name" => "passwordsample",
		"class" => "sample1"));
?>
</td>
</tr>

<tr>
<td>textarea</td>
<td>
<?php

$def_str = 
"This is \"sample\" text.\n".
"'Thank you for selecting poko2.'".
"And test of <textarea> interface function\n";

$value = ($HTTP_POST_VARS["memo"] == "") ?
			$def_str :
			$HTTP_POST_VARS["memo"];

$form->TextAreaForm(array(
		"rows" => "5", "cols" => "20",
		"name" => "memo", "class" => "sample1"),
		$value);
?>
</td>
</tr>

<tr>
<td>file</td>
<td>
<?php
	$form->FileSizeForm(100000);
	$form->FileForm(array(
				"size" => 20,
				"class" => "sample1"));
?>
</td>
</tr>

<tr>
<td>radio</td>
<td>
<?php
for($i = 0; $i < 3; $i++)
	$form->RadioForm(array("name" => "r", "value" => $i,
					"class" => "sample1"),
					"'Radio$i'");
?>
</td>
</tr>

<tr>
<td>checkbox</td>
<td>
<?php
for($i = 0; $i < 3; $i++)
	$form->CheckBoxForm(array("name" => "cb", "value" => $i,
					"class" => "sample1"),
					"\"CheckBox$i\"");
?>
</td>
</tr>

<tr>
<td>select</td>
<td>
<?php $form->SelectForm(array("name" => "s", "class" => "sample1"),
		array(
			"\"label1\"" => "\"value1\"",
			"'label2'" => "'value2'",
			"label3" => "value3"),
		1);
?>
</td>
</tr>

<tr>
<td>submit</td>
<td>
<?php $form->SubmitForm(array(
				"value" => ">> Send >>",
				"class" => "sample1"));
?>
</td>
</tr>

<tr>
<td>reset</td>
<td>
<?php $form->ResetForm(array(
				"value" => "<< Clean <<",
				"class" => "sample1"));
?>
</td>
</tr>

</table>
<br>
Confirm HTML source and hidden forms.
<?php
$form->HiddenForm(array(
		"data1" => "\"Sample\"",
		"data2" => "'Sample'",
		"data3" => "<Sample>"
		));

$form->EndForm();

?>
</body>
</html>
